package com.christian.christian_picker_image

import android.app.Activity
import android.content.Context
import android.content.Intent
import java.util.ArrayList
import android.os.Environment
import android.support.v4.app.ActivityCompat
//import com.christian.christian_picker_image.camera.CameraActivity

import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.PluginRegistry.Registrar
import io.flutter.view.FlutterView
import com.esafirm.imagepicker.features.ImagePicker
import com.esafirm.imagepicker.model.Image

/**
 * ChristianPickerImagePlugin
 */
class ChristianPickerImagePlugin : MethodCallHandler, PluginRegistry.ActivityResultListener, PluginRegistry.RequestPermissionsResultListener {

    private val view: FlutterView? = null
    private var pendingResult: Result? = null
    private val methodCall: MethodCall? = null

    private var context: Context? = null
    private var activity: Activity? = null
    private var channel: MethodChannel? = null
    private var messenger: BinaryMessenger? = null

    private val REQUEST_CODE_CHOOSE = 1001
    private val REQUEST_CODE_GRANT_PERMISSIONS = 2001

    private val NumberOfImagesToSelect = 5

    private constructor(_activity: Activity, _context: Context, _channel: MethodChannel, _messenger: BinaryMessenger) {
        this.activity = _activity
        this.context = _context
        this.channel = _channel
        this.messenger = _messenger
    }


    override fun onRequestPermissionsResult(requestCode: Int, permissions: Array<String>, grantResults: IntArray): Boolean {
        //        if (requestCode == REQUEST_CODE_GRANT_PERMISSIONS && permissions.length == 3) {
        //            if (grantResults[0] == PackageManager.PERMISSION_GRANTED
        //                    && grantResults[1] == PackageManager.PERMISSION_GRANTED
        //                    && grantResults[2] == PackageManager.PERMISSION_GRANTED) {
        //                int maxImages = (int) this.methodCall.argument(MAX_IMAGES);
        //                boolean enableCamera = (boolean) this.methodCall.argument(ENABLE_CAMERA);
        //                HashMap<String, String> options = this.methodCall.argument(ANDROID_OPTIONS);
        //                ArrayList<String> selectedAssets = this.methodCall.argument(SELECTED_ASSETS);
        //                assert options != null;
        //                presentPicker(maxImages, enableCamera, selectedAssets, options);
        //            } else {
        //                if (
        //                        ActivityCompat.shouldShowRequestPermissionRationale(activity, Manifest.permission.READ_EXTERNAL_STORAGE) ||
        //                                ActivityCompat.shouldShowRequestPermissionRationale(activity, Manifest.permission.WRITE_EXTERNAL_STORAGE) ||
        //                                ActivityCompat.shouldShowRequestPermissionRationale(activity, Manifest.permission.CAMERA)) {
        //                    finishWithError("PERMISSION_DENIED", "Read, write or camera permission was not granted");
        //                } else{
        //                    finishWithError("PERMISSION_PERMANENTLY_DENIED", "Please enable access to the storage and the camera.");
        //                }
        //                return false;
        //            }
        //
        //            return true;
        //        }
        //        finishWithError("PERMISSION_DENIED", "Read, write or camera permission was not granted");

        return false
    }

    private fun presentPicker(maxImages: Int) {
        //val intent = Intent(context, CameraActivity::class.java)
//        //intent.putParcelableArrayListExtra(Constants.Activity.PHOTO_SELECTED, array)
//        ActivityCompat.startActivityForResult(this.activity, intent, 100, null)
        ImagePicker.create(this.activity)
                .limit(5)
                .showCamera(true)// Activity or Fragment
                .start();
    }

    override fun onMethodCall(call: MethodCall, result: Result) {

        this.pendingResult = result;

        when (call.method) {
            PICK_IMAGES -> {
                val maxImages = call.argument<Int>(MAX_IMAGES)!!

                if (maxImages <= 0) {
                    return
                }

                presentPicker(maxImages)
            }
            "getPlatformVersion" -> result.success("Android " + android.os.Build.VERSION.RELEASE)
            else -> result.notImplemented()
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent): Boolean {

        if (ImagePicker.shouldHandle(requestCode, resultCode, data)) {
            // Get a list of picked images
            val images: List<Image> = ImagePicker.getImages (data)
            val list: ArrayList<Map<String,String>> = ArrayList<Map<String,String>>(0)

            for (image in images) {
                val containerMap = HashMap<String, String>()
                containerMap.put("path", image.path)
                list.add(containerMap)
            }

            this.pendingResult?.success(list)
        }

        return false
    }

    companion object {

        private val PICK_IMAGES = "pickImages"
        private val REFRESH_IMAGE = "refreshImage"
        private val MAX_IMAGES = "maxImages"
        private val ANDROID_OPTIONS = "androidOptions"

        private val SELECTED_ASSETS = "selectedAssets"
        private val ENABLE_CAMERA = "enableCamera"
        private val REQUEST_CODE_CHOOSE = 1001
        private val REQUEST_CODE_GRANT_PERMISSIONS = 2001

        /**
         * Plugin registration.
         */
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "christian_picker_image")
            val instance = ChristianPickerImagePlugin(registrar.activity(), registrar.context(), channel, registrar.messenger())
            val externalFilesDirectory = registrar.activity().getExternalFilesDir(Environment.DIRECTORY_PICTURES)
            registrar.addActivityResultListener(instance);
            channel.setMethodCallHandler(instance)
        }
    }

}
